import useSWR, { useSWRConfig } from "swr";
import type { Document } from "dbtype";
import { fetcher } from "./fetcher";

export function useGalleryDoc(id: string) {
    return useSWR<Document>(`/api/doc/${id}`, fetcher);
}

export function useRehashDoc() {
    const { mutate } = useSWRConfig();
    return async (id: string) => {
        await fetch(`/api/doc/${id}/_rehash`, {
            method: "POST",
        });
        mutate(`/api/doc/${id}`);
    };
}

export function useGalleryDocSimilar(id: string) {
    return useSWR<Document[]>(`/api/doc/${id}/similars`, fetcher);
}