import type { KyselyPlugin, PluginTransformQueryArgs, PluginTransformResultArgs, QueryResult, RootOperationNode, UnknownRow } from "kysely";

export class MyParseJSONResultsPlugin implements KyselyPlugin {

    constructor(private readonly itemPath: string) { }

    transformQuery(args: PluginTransformQueryArgs): RootOperationNode {
        // do nothing
        return args.node;
    }
    async transformResult(args: PluginTransformResultArgs): Promise<QueryResult<UnknownRow>> {
        return {
            ...args.result,
            rows: args.result.rows.map((row) => {
                const newRow = { ...row };
                const item = newRow[this.itemPath];
                if (typeof item === "string") {
                    newRow[this.itemPath] = JSON.parse(item);
                }
                return newRow;
            })
        }
    }
}